<template>
  <div class="formula-block">
    <div class="formula-block__element" v-for="item in items" :key="item.id">
      <div v-if="item.tipBelow" class="formula-block__element__bottom-tip">
        <div class="formula-block__label-wrapper">
          <div class="formula-block__label">{{item.label}}</div>
          <sub v-if="item.index">{{item.index}}</sub>
        </div>
        <span
          class="formula-block__element__bottom-tip__body"
          :class="[item.tipPositionClass, item.tipSizeClass]"
        >{{item.tipBelow}}</span>
      </div>

      <div v-else-if="item.tipAbove" class="formula-block__element__top-tip">
        <div class="formula-block__label-wrapper">
          <div class="formula-block__label">{{item.label}}</div>
          <sub v-if="item.index">{{item.index}}</sub>
        </div>
        <span
          class="formula-block__element__top-tip__body"
          :class="[item.tipPositionClass, item.tipSizeClass]"
        >{{item.tipAbove}}</span>
      </div>
      <div v-else :class="[item.isOperator === true ? 'formula-block__element__symbol' : '']">
        <span>{{item.label}}</span>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: 'formula',

  props: {
    items: {
      type: Array,
      default: () => [],
    },
    label: {
      type: String,
      default: '',
    },
    index: {
      type: String,
      default: '',
    },
    tipAbove: {
      type: String,
      default: '',
    },
    tipBelow: {
      type: String,
      default: '',
    },
    tipPositionClass: {
      type: String,
      default: 'align-center',
    },
    tipSizeClass: {
      type: String,
      default: 'normal',
    },
    isOperator: {
      type: Boolean,
      default: false,
    },
  },
};
</script>

<style lang="scss" scoped>
$cobalt-black: #191e32;
$shale-gray: #474b5b;
$gray-slate: #737682;

@import '~common-components/src/static/css/mixins';

.formula-block {
  display: flex;
  justify-content: center;
  padding: 70px 0 55px;
  margin: 40px 0;
  &__element {
    @include font-mixin(32px, 37px, 400, $shale-gray, 0.2px);
    sub {
      font-size: 10px;
      text-transform: uppercase;
      margin-left: 0px;
    }
    &__bottom-tip {
      position: relative;
      height: 100%;
      .formula-block__label-wrapper {
        display: flex;
        align-items: baseline;
      }
      .formula-block__label {
        position: relative;
        text-align: center;
        &:after {
          content: '';
          position: absolute;
          width: 1px;
          height: 30px;
          background: #9da0ac;
          left: 50%;
          bottom: -30px;
        }
      }
      
      &__body {
        top: 75px;
        &.narrow {
          min-width: 110px;
          &.align-left {
            left: 0px;
            text-align: left;
          }
          &.align-right {
            left: -40px;
            text-align: right;
          }
          &.align-center {
            left: 15px;
            text-align: left;
          }
        }
        &.mid {
           min-width: 210px;
            &.align-right {
              left: -175px;
              text-align: right;
            }
            &.align-left {
              left: 25px;
              text-align: left;
            }
        }
        &.wide {
          min-width: 275px;
          &.align-right {
            left: -175px;
            text-align: right;
          }
          &.align-left {
            left: 50px;
            text-align: left;
          }
        }
      }
    }
    &__top-tip {
      position: relative;
      height: 100%;
      .formula-block__label-wrapper {
        display: flex;
        align-items: baseline;
      }
      .formula-block__label {
        position: relative;
        text-align: center;
        &:after {
          content: '';
          position: absolute;
          width: 1px;
          height: 30px;
          background: #9da0ac;
          left: 50%;
          top: -35px;
        }
      }
      &__body {
        bottom: 85px;
        &.narrow {
          &.align-left {
            left: 40px;
            text-align: left;
            min-width: 110px;
          }
          &.align-right {
            left: -65px;
            text-align: right;
            min-width: 120px;
          }
          &.align-center {
            left: 20px;
            text-align: left;
            min-width: 100px;
          }
        }
        &.mid {
          min-width: 170px;
          &.align-left {
            left: 40px;
            text-align: left;
          }
          &.align-right {
            left: -110px;
            text-align: right;
          }
          &.align-center {
            left: 20px;
            text-align: left;
          }
        }
        &.wide {
          &.align-right {
            left: -175px;
            text-align: right;
            min-width: 275px;
          }
          &.align-left {
            left: 50px;
            text-align: left;
            min-width: 275px;
          }
        }
      }
    }
    &__top-tip__body,
    &__bottom-tip__body {
      @include font-mixin(10px, 13px, 400, $gray-slate, 0.4px);
      position: absolute;
      left: 100%;
      transform: translateX(-20%);
      min-width: 155px;
      text-transform: uppercase;
      word-break: break-word;
    }
    &__symbol {
      margin: 0 8px;
    }
  }
}
.section-title {
  @include font-mixin(16px, 20px, bold, $cobalt-black, 0.4px);
}
.symbol-box {
  @include font-mixin(32px, 37px, 400, $shale-gray, 0.2px);
  text-align: center;
}
.box-input {
  width: 70px;
}
</style>